#include "standart.h"
//#include <commctrl.h>


#include <dshow.h> 
#include <qedit.h>
#include <atlbase.h> 
#include <atlconv.h>
#include <initguid.h>

#include <cv.h>
#include <cvcam.h>
#include <cxcore.h>
#include <highgui.h>
#include <time.h>
#include <iProxyTrans.h>
#include <ProxyTransuids.h>
#include <iSyncFilter.h>
#include <SyncFilterUIDs.h>

#pragma comment ( lib, "strmiids.lib" )
//#pragma comment(lib,"highgui.lib" )
#pragma comment(lib,"cv.lib" )
#pragma comment(lib,"cvcam.lib" )
#pragma comment(lib,"cxcore.lib" )
//#pragma comment(lib,"ProxyTrans.lib" )

//#pragma comment(lib,"cvaux.lib" )
//#pragma comment(lib,"cxts.lib" )
//#pragma comment(lib,"ml.lib" )
//#pragma comment(lib,"cvhaartraining.lib" )

#define FRAME_WIDTH		640
#define FRAME_HEIGHT	480
#define FRAME_RATE		15

#define	CAMERA_LEFT_NAME		"@device:pnp:\\\\?\\usb#vid_046d&pid_08a9&mi_00#6&196e7674&1&0000#{65e8773d-8f56-11d0-a3b9-00a0c9223196}\\global"
#define	CAMERA_RIGHT_NAME		"@device:pnp:\\\\?\\usb#vid_046d&pid_08a9&mi_00#7&2c141bb7&0&0000#{65e8773d-8f56-11d0-a3b9-00a0c9223196}\\global"


IplImage		*image1024x512Left, *image1024x512Right, *imageLeft, *imageRight;
CvCapture		*capLeft, *capRight; 
GLuint			texLeft, texRight;
int				iCamCount = 0;
float			coefX, coefY;
char			*FameBufferLeft[FRAME_WIDTH*FRAME_HEIGHT*3];
char			*FameBufferRight[FRAME_WIDTH*FRAME_HEIGHT*3];

ICaptureGraphBuilder2			*pCaptureGraphBuilder=NULL;
IGraphBuilder					*pGraphBuilder=NULL;

IBaseFilter						*pCameraLeft=NULL, *pCameraRight=NULL;
IMediaControl					*pMediaControl= NULL;
//NullRenderer					*pNullRendererLeft, pNullRendererRight;
IBaseFilter						*pNullRendererFilterLeft= NULL, *pNullRendererFilterRight= NULL;
ISyncFilter						*pSync= NULL;
IBaseFilter						*pSyncFilter= NULL;

HRESULT	FindMyCaptureDevice(IBaseFilter**, char*);
void	callbackStereo(IplImage*, IplImage*);
HRESULT	SetMediaParameters(IBaseFilter*, int, int, int);
HRESULT	initDirectShow(void);
void	deinitDirectShow(void);
HRESULT GetPin(PIN_INFO* , CComPtr<IPin>& );
HRESULT ConnectFilters(IBaseFilter* , IBaseFilter* , IGraphBuilder* );

//    DirectShow SDK
//         .
// : [in]  PIN_INFO* pPinInfo  -      (. DS SDK)
//            [out] CComPtr<IPin>& pPin -  
HRESULT	GetPin(PIN_INFO* pPinInfo, CComPtr<IPin>& pPin)
{
	HRESULT hr;

	if (!pPinInfo) return E_POINTER;

	if (pPinInfo->pFilter)
	{
		CComPtr<IEnumPins> pEnumPins;
		ULONG cFetched;
		hr = pPinInfo->pFilter->EnumPins(&pEnumPins);
		ATLASSERT(pEnumPins);
		//    
		while(pEnumPins->Next(1, &pPin, &cFetched) == S_OK)
		{
			PIN_INFO piPinInfo;
			//         PinInfo
			hr = pPin->QueryPinInfo(&piPinInfo);
			if (SUCCEEDED(hr))
			{
				//   
				//    ,   '~'  
				// GraphBuilder    .
				if (piPinInfo.dir == pPinInfo->dir && piPinInfo.achName[0] != L'~')
				{
					//    ,   
					//   ConnectedTo().
					CComPtr<IPin> pConnectedPin;
					hr = pPin->ConnectedTo(&pConnectedPin);
					if (hr == VFW_E_NOT_CONNECTED || !pConnectedPin)
					{
						hr = S_OK;
						break;
					}
				}
			}
			pPin = NULL;    //      
		}
	}
	else
	{
		hr = E_INVALIDARG;
	}

	return hr;
}



//       
// : [in] IBaseFilter* pSourceFilter   -   
//            [in] IBaseFilter* pReceiveFilter  -   
//            [in] IGraphBuilder* pGraphBuilder -  GraphBuilder
HRESULT	ConnectFilters(IBaseFilter* pSourceFilter, IBaseFilter* pReceiveFilter, IGraphBuilder* pGraphBuilder)
{
	HRESULT hr;
	CComPtr<IPin> pOutputPin;
	CComPtr<IPin> pInputPin;

	PIN_INFO piPinInfo = {pSourceFilter, PINDIR_OUTPUT, {0}};
	//   
	hr = GetPin(&piPinInfo, pOutputPin);
	if (SUCCEEDED(hr))
	{
		ATLASSERT(pOutputPin);
		piPinInfo.pFilter = pReceiveFilter;
		piPinInfo.dir = PINDIR_INPUT;
		//   
		hr = GetPin(&piPinInfo, pInputPin);
		//   
		if (SUCCEEDED(hr))
			hr = pGraphBuilder->Connect(pOutputPin, pInputPin);
	}

	return hr;
}




HRESULT	initDirectShow(void)
{
int				iCameraCount = 0;
HRESULT			hr = S_OK;	

	CoInitialize( NULL ); 

	//  
	if( FAILED( CoCreateInstance( CLSID_FilterGraph, NULL, CLSCTX_INPROC_SERVER, IID_IGraphBuilder, ( void ** )&pGraphBuilder )) )
	{
		MessageBox(NULL, "  FilterGraph  .", "Error",	MB_ICONERROR | MB_OK);
		return S_FALSE;
	}
	//  MediaControl
	if( FAILED( pGraphBuilder->QueryInterface( IID_IMediaControl, ( void ** )&pMediaControl)) )
	{
		MessageBox(NULL, "  MediaControl  .", "Error",	MB_ICONERROR | MB_OK);
		return S_FALSE;
	}

	
	//   SyncFilter
	if( FAILED(CoCreateInstance(CLSID_SyncFilter, NULL, CLSCTX_INPROC_SERVER, IID_ISyncFilter, (void**)&pSync)))
	{
		MessageBox(NULL, "  ISyncFilter  ,      .", "Error",	MB_ICONERROR | MB_OK);
		return S_FALSE;

	}

	pSync->SetCallBack((void(*)(void*, void*))callbackStereo);
	pSync->QueryInterface(IID_IBaseFilter, (void**)&pSyncFilter);
	pGraphBuilder->AddFilter(pSyncFilter, L"Script processing");

	
	//  CaptureGraphBuilder
	if( FAILED( CoCreateInstance( CLSID_CaptureGraphBuilder2, NULL, CLSCTX_INPROC_SERVER, IID_ICaptureGraphBuilder2, ( void ** )&pCaptureGraphBuilder )) )
	{
		MessageBox(NULL, "  CaptureGraphBuilder  .", "Error",	MB_ICONERROR | MB_OK);
		return S_FALSE;
	}

	if( FAILED( pCaptureGraphBuilder->SetFiltergraph(pGraphBuilder) ))
	{
		MessageBox(NULL, "  CaptureGraphBuilder->SetFiltergraph  .", "Error",	MB_ICONERROR | MB_OK);
		return S_FALSE;
	}


	//      
	hr = FindMyCaptureDevice(&pCameraLeft, CAMERA_LEFT_NAME);
	if( hr == S_OK )
	{
		pGraphBuilder->AddFilter(pCameraLeft, L"VideoCaptureFilter");
		SetMediaParameters(pCameraLeft, FRAME_WIDTH, FRAME_HEIGHT, FRAME_RATE);

		//   NullRenderer
		if( FAILED( CoCreateInstance(CLSID_NullRenderer, NULL, CLSCTX_INPROC_SERVER, IID_IBaseFilter, (void **)&pNullRendererFilterLeft)) )
		{
			MessageBox(NULL, "  NullRenderer  .", "Error",	MB_ICONERROR | MB_OK);
			return S_FALSE;
		}
		//  NullRenderer  GraphBuilder
		if( FAILED( pGraphBuilder->AddFilter(pNullRendererFilterLeft, L"NullRenderer")))
		{
			MessageBox(NULL, "  NullRenderer  GraphBuilder  .", "Error",	MB_ICONERROR | MB_OK);
			return S_FALSE;
		}

		ConnectFilters(pCameraLeft, pSyncFilter, pGraphBuilder);
		ConnectFilters(pSyncFilter, pNullRendererFilterLeft, pGraphBuilder);

		//hr = pCaptureGraphBuilder->RenderStream(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Video, pCameraLeft, pProxyFilterLeft, pNullRendererFilterLeft);
		//hr = pCaptureGraphBuilder->RenderStream(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Video, pCameraLeft, pSyncFilter, NULL);

	}
	else
	{
		MessageBox(NULL, "   .", "Error",	MB_ICONERROR | MB_OK);
	}


	//      
	hr = FindMyCaptureDevice(&pCameraRight, CAMERA_RIGHT_NAME);
	if( hr == S_OK )
	{
		pGraphBuilder->AddFilter(pCameraRight, L"VideoCaptureFilter");
		SetMediaParameters(pCameraRight, FRAME_WIDTH, FRAME_HEIGHT, FRAME_RATE);

		//   NullRenderer
		if( FAILED( CoCreateInstance(CLSID_NullRenderer, NULL, CLSCTX_INPROC_SERVER, IID_IBaseFilter, (void **)&pNullRendererFilterRight)) )
		{
			MessageBox(NULL, "  NullRenderer  .", "Error",	MB_ICONERROR | MB_OK);
			return S_FALSE;
		}

		//  NullRenderer  GraphBuilder
		if( FAILED( pGraphBuilder->AddFilter(pNullRendererFilterRight, L"NullRenderer")))
		{
			MessageBox(NULL, "  NullRenderer  GraphBuilder  .", "Error",	MB_ICONERROR | MB_OK);
			return S_FALSE;
		}

		ConnectFilters(pCameraRight, pSyncFilter, pGraphBuilder);
		ConnectFilters(pSyncFilter, pNullRendererFilterRight, pGraphBuilder);

		//hr = pCaptureGraphBuilder->RenderStream(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Video, pCameraRight, pProxyFilterRight, pNullRendererFilterRight);
		//hr = pCaptureGraphBuilder->RenderStream(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Video, pCameraRight, pSyncFilter, NULL);


	}
	else
	{
		MessageBox(NULL, "   .", "Error",	MB_ICONERROR | MB_OK);
	}
	
	pMediaControl->Run();
	
	return S_OK;
}

void	deinitDirectShow(void)
{
	if (pMediaControl)
		pMediaControl->Stop();

	if(pNullRendererFilterLeft)
		pNullRendererFilterLeft->Release();

	if(pNullRendererFilterRight)
		pNullRendererFilterRight->Release();

	if(pSyncFilter)
		pSyncFilter->Release();
	
	if(pCaptureGraphBuilder)
		pCaptureGraphBuilder->Release();

	if(pGraphBuilder)
		pGraphBuilder->Release();

	CoUninitialize();
}
void	callbackStereo(IplImage* image_Left, IplImage* image_Right)
{
	if(image_Left->imageData != NULL)
	{
		*imageLeft = *image_Left;
	}
	
	if(image_Right->imageData != NULL)
	{
		*imageRight = *image_Right;
	}

}


HRESULT	SetMediaParameters(IBaseFilter *pBaseFilter, int	iWidth, int iHeight, int iFPS)
{
	//int								CapCount, CapSize;
	HRESULT							hResult = S_OK;
	IAMStreamConfig					*pAMStreamConfig;

	hResult = pCaptureGraphBuilder->FindInterface(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Video, pBaseFilter, IID_IAMStreamConfig,(void**) &pAMStreamConfig);
	if( FAILED( hResult ))
	{
		MessageBox(NULL, "   AMStreamConfig  CaptureGraphBuilder.", "",	MB_ICONERROR | MB_OK);
		return hResult;
	}

	//pAMStreamConfig->GetNumberOfCapabilities(&CapCount, &CapSize);

	AM_MEDIA_TYPE *pMediaType= new AM_MEDIA_TYPE;

	hResult = pAMStreamConfig->GetFormat(&pMediaType);
	if( FAILED( hResult ))
	{
		MessageBox(NULL, "    AM_MEDIA_TYPE.", "",	MB_ICONERROR | MB_OK);
		return hResult;
	}

	//if ( (pMediaType->formattype == FORMAT_VideoInfo) && (pMediaType->cbFormat > sizeof(VIDEOINFOHEADER)) && (pMediaType->pbFormat != NULL))

	VIDEOINFOHEADER *pVideoInfoHeader = (VIDEOINFOHEADER*)pMediaType->pbFormat;
	pVideoInfoHeader->bmiHeader.biWidth = iWidth;//352;
	pVideoInfoHeader->bmiHeader.biHeight = iHeight;//288;
	pVideoInfoHeader->AvgTimePerFrame = 10000000/iFPS;
	pVideoInfoHeader->bmiHeader.biSizeImage = iWidth*iHeight*3;
	pMediaType->lSampleSize = pVideoInfoHeader->bmiHeader.biSizeImage;
	hResult = pAMStreamConfig->SetFormat(pMediaType);

	if( FAILED( hResult ))
		MessageBox(NULL, "    AM_MEDIA_TYPE.", "",	MB_ICONERROR | MB_OK);

	return hResult;
}





HRESULT	FindMyCaptureDevice(IBaseFilter **pF, char *szFilterName)
{
USES_CONVERSION;	

	ICreateDevEnum					*pSysDevEnum;
	IMoniker						*pMoniker;
	IPropertyBag					*pProp;
	IEnumMoniker					*pEnumMoniker;
	IBaseFilter						*pFilter; 

	ULONG							cFetched;
	LPOLESTR						lpostrDisplayName=NULL;
	LPSTR							szDisplayName;

	HRESULT							hResult = S_OK;	



	hResult = CoCreateInstance( CLSID_SystemDeviceEnum, NULL, CLSCTX_INPROC_SERVER, IID_ICreateDevEnum, ( void ** )&pSysDevEnum );
	if( FAILED(hResult) )
	{
		MessageBox(NULL, "     .", "Error",	MB_ICONERROR | MB_OK);
		return hResult;
	}

	hResult = pSysDevEnum->CreateClassEnumerator(CLSID_VideoInputDeviceCategory, &pEnumMoniker, 0);
	if( FAILED(hResult) )
	{
		MessageBox(NULL, "     .", "Error",	MB_ICONERROR | MB_OK);
		return hResult;
	}

	while(  pEnumMoniker->Next(1, &pMoniker, &cFetched) == S_OK )
	{
		//  
		hResult = pMoniker->BindToStorage(0, 0, IID_IPropertyBag, (void **)&pProp);
		//   
		pMoniker->GetDisplayName(NULL, NULL, &lpostrDisplayName);
		szDisplayName = OLE2A(lpostrDisplayName);
		
		if (SUCCEEDED(hResult) && (lstrcmp(szDisplayName, szFilterName) == 0))
		{
			//   
			hResult = pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void**)&pFilter);
			*pF = pFilter;
			(*pF)->AddRef();
			break;
		}
		pMoniker = NULL;
		hResult = S_FALSE;
	}

	pEnumMoniker->Release();
	pSysDevEnum->Release();
	
	return hResult;
}



void	ResizeGLWindow(int WindowWidth, int WindowHeight)
{
	glViewport(0, 0, WindowWidth, WindowHeight);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(-2, 2, -2, 2, 20, -20);
	//gluPerspective(20.0,(double)WindowWidth/WindowHeight,0.5,300);
}



void	InitializeGLWindow(void)
{

	//glHint (GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
	glDepthFunc(GL_LEQUAL);

	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	//glLightModelf(GL_LIGHT_MODEL_TWO_SIDE,GL_FALSE);

	//glEnable(GL_NORMALIZE);
   //glEnable(GL_AUTO_NORMAL);

	//glEnable(GL_POLYGON_SMOOTH);
	//glShadeModel(GL_SMOOTH);
	glDisable(GL_CULL_FACE);
	glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
	glEnable(GL_COLOR_MATERIAL);

	/*
	GLenum err = glGetError();
	if(err != GL_NO_ERROR)
	{
		MessageBox(NULL, (LPCSTR)gluErrorString(err), "Error",	MB_ICONERROR | MB_OK);
	}
	*/
	//glEnable (GL_DEPTH_TEST);
	glEnable (GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	

	glDisable(GL_DEPTH_TEST);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE);

	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);


	iCamCount = initDirectShow();
		
	image1024x512Left	= cvCreateImage( cvSize(1024, 512), 8, 3 );
	image1024x512Right	= cvCreateImage( cvSize(1024, 512), 8, 3 );

	imageLeft			= cvCreateImage( cvSize(FRAME_WIDTH, FRAME_HEIGHT), 8, 3 );
	imageRight			= cvCreateImage( cvSize(FRAME_WIDTH, FRAME_HEIGHT), 8, 3 );


	glGenTextures(1, &texLeft);	
	glGenTextures(1, &texRight);	

	glBindTexture(GL_TEXTURE_2D, texLeft);							
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);

	glTexImage2D(GL_TEXTURE_2D, 0, 3, image1024x512Left->width, image1024x512Left->height, 0, GL_RGB, GL_UNSIGNED_BYTE, image1024x512Left->imageData);

	glBindTexture(GL_TEXTURE_2D, texRight);							
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);

	glTexImage2D(GL_TEXTURE_2D, 0, 3, image1024x512Right->width, image1024x512Right->height, 0, GL_RGB, GL_UNSIGNED_BYTE, image1024x512Right->imageData);

	GLenum err = glGetError();
	if(err != GL_NO_ERROR)
	{
		MessageBox(NULL, (LPCSTR)gluErrorString(err), "Error",	MB_ICONERROR | MB_OK);
	}

	coefX = (float)FRAME_WIDTH/1024;
	coefY = (float)FRAME_HEIGHT/512;
}








void	DeinitializeGLWindow(void)
{
	
	deinitDirectShow();

	cvReleaseImage(&image1024x512Left);
	cvReleaseImage(&image1024x512Right);
	//cvReleaseImage(&imageLeft);
	//imageLeft->imageData = NULL;
	//cvReleaseImage(&imageRight);
	//imageRight->imageData = NULL;

	
}



void	RedrawGLWindow()
{
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glPushMatrix();

	//glTranslatef(1.15F, 0.1F, 0.0F);
	glColor4f(1,1,1,0.5);

	glBindTexture(GL_TEXTURE_2D, texLeft);
	glTexSubImage2D (GL_TEXTURE_2D, 0, 0, 0, imageLeft->width, imageLeft->height, GL_BGR_EXT, GL_UNSIGNED_BYTE, imageLeft->imageData);


	glNormal3f( 0.0F,  0.0F, 1.0F);
	glBegin(GL_QUADS);
		glTexCoord2f(0.0F,	coefY);		glVertex3f(-2.0f,   2.0f,	-2.0F);
		glTexCoord2f(coefX, coefY);		glVertex3f( 2.0f,	2.0f,	-2.0F);
		glTexCoord2f(coefX,		0);		glVertex3f( 2.0f,	-2.0f,  -2.0F);
		glTexCoord2f(0.0F,		0);		glVertex3f(-2.0f,	-2.0f,  -2.0F);
	glEnd();


	glColor4f(1,1,1,0.5);

	glBindTexture(GL_TEXTURE_2D, texRight);
	glTexSubImage2D (GL_TEXTURE_2D, 0, 0, 0, imageRight->width, imageRight->height, GL_BGR_EXT, GL_UNSIGNED_BYTE, imageRight->imageData);

	glNormal3f( 0.0F,  0.0F, 1.0F);
	glBegin(GL_QUADS);
		glTexCoord2f(0.0F,	coefY);		glVertex3f(-2.0f,   2.0f,	-2.0F);
		glTexCoord2f(coefX, coefY);		glVertex3f( 2.0f,	2.0f,	-2.0F);
		glTexCoord2f(coefX,		0);		glVertex3f( 2.0f,	-2.0f,  -2.0F);
		glTexCoord2f(0.0F,		0);		glVertex3f(-2.0f,	-2.0f,  -2.0F);
	glEnd();
	
	glPopMatrix();


	glFlush();
	Sleep(10);
}







