#include <windows.h>
#include <GL/gl.h>
#include <GL/glext.h>
#include <GL/glu.h>


#define WINDOW_WIDTH		800
#define WINDOW_HEIGHT		600


#pragma comment( lib, "opengl32.lib" )                        
#pragma comment( lib, "glu32.lib"    )


bool						bDone = false;
int							WindowWidth, WindowHeight;
HWND						hWnd;
HDC							hDC;
HGLRC						hGLRC;


bool		CreateMyGLWindow(HWND &hWnd, HGLRC &hGLRC, HDC &hDC, LPCTSTR, LPCTSTR, HINSTANCE, WNDPROC, DWORD, DWORD, int, int, int, int, WORD, HBRUSH, LPCTSTR);
void		KillMyGLWindow(HGLRC hGLRC);
LRESULT		CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
void		InitializeGLWindow(void);
void		DeinitializeGLWindow(void);
void		ResizeGLWindow(int, int);
void		RedrawGLWindow(void);



bool CreateMyGLWindow(HWND &hWnd, HGLRC &hGLRC, HDC &hDC, LPCTSTR className, LPCTSTR windowName, HINSTANCE hCurrentInst, WNDPROC WndProc, DWORD winStyle,DWORD winState, int winX, int winY, int winWidth, int winHeight, WORD icon, HBRUSH hbrBackground, LPCTSTR lpszMenu)
{
WNDCLASS					wndClass;
int							pixelFormat;

PIXELFORMATDESCRIPTOR		pfd =
							{
								sizeof(PIXELFORMATDESCRIPTOR),	
								1,				         
								PFD_SUPPORT_OPENGL |
								PFD_DRAW_TO_WINDOW |
								PFD_DOUBLEBUFFER,		
								PFD_TYPE_RGBA,			
								32,	     			   
								0, 0, 0, 0, 0, 0,		
								0,				         
								0,				        
								0,				        
								0, 0, 0, 0,			  
								16,				      
								0,				         
								0,				         
								PFD_MAIN_PLANE,		
								0,				        
								0, 0, 0,			      
							};


	wndClass.style = CS_OWNDC | CS_HREDRAW | CS_VREDRAW;
	wndClass.lpfnWndProc = WndProc;
	wndClass.cbClsExtra = 0;
	wndClass.cbWndExtra = 0;
	wndClass.hInstance = hCurrentInst;
	wndClass.hIcon = LoadIcon(hCurrentInst,MAKEINTRESOURCE(icon));
	wndClass.hCursor = LoadCursor(NULL, IDC_ARROW);
	wndClass.hbrBackground =hbrBackground;
	wndClass.lpszMenuName = lpszMenu;
	wndClass.lpszClassName = className;
	RegisterClass(&wndClass);

	hWnd = CreateWindowEx(NULL, className, windowName, winStyle,
   						 winX, winY, winWidth, winHeight,
						  NULL, NULL, hCurrentInst, NULL);

	if (!hWnd)
    {
		MessageBox(NULL, "  .", "Error",	MB_ICONERROR | MB_OK);
		bDone = true;
		return false;
    }

	ShowWindow(hWnd, winState);
	UpdateWindow(hWnd);

	hDC = GetDC(hWnd);

    pixelFormat = ChoosePixelFormat(hDC, &pfd);

    if (pixelFormat == 0)
    {
		MessageBox(NULL, "   .", "Error",	MB_ICONERROR | MB_OK);
		bDone = true;
		return false;
    }

	if (SetPixelFormat(hDC, pixelFormat, &pfd) != TRUE)
    {
		MessageBox(NULL, "   .", "Error", MB_ICONERROR | MB_OK);
		bDone = true;
		return false;
    }

	hGLRC = wglCreateContext(hDC);
	if (!hGLRC)
    {
		MessageBox(NULL, "   .", "Error", MB_ICONERROR | MB_OK);
		bDone = true;
		return false;
    }

	wglMakeCurrent(hDC, hGLRC);

	return true;
}


void	KillMyGLWindow(HGLRC hGLRC)
{
	DeinitializeGLWindow();

	if(hGLRC)
	{
		wglMakeCurrent(NULL, NULL);
		wglDeleteContext(hGLRC);
	}
}





int APIENTRY WinMain(HINSTANCE hCurrentInst, HINSTANCE hPreviousInst, LPSTR lpszCmdLine, int nCmdShow)
{
MSG							msg;
//HGLRC						hGLRC;
//HWND						hWnd;
//HDC							hDC;

	WindowWidth = WINDOW_WIDTH;
	WindowHeight= WINDOW_HEIGHT;
	//WindowWidth = GetSystemMetrics(SM_CXSCREEN);
	//WindowHeight= GetSystemMetrics(SM_CYSCREEN);
	
	CreateMyGLWindow(hWnd, hGLRC, hDC, "GLwindow", "PlayAVI", hCurrentInst, WndProc, WS_OVERLAPPEDWINDOW, SW_SHOW, 0, 0, WindowWidth, WindowHeight, NULL, (HBRUSH)GetStockObject(BLACK_BRUSH), NULL);

	ResizeGLWindow(WindowWidth, WindowHeight);

	InitializeGLWindow();	
	
	while(!bDone)
	{
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))
		{
			if(msg.message==WM_QUIT) bDone=TRUE;
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		else
		{
			RedrawGLWindow();
			SwapBuffers(hDC);
		}
	}

	DeinitializeGLWindow();

	SendMessage(hWnd, WM_DESTROY, NULL, NULL);

	//return LOWORD(msg.wParam);

}






LRESULT CALLBACK WndProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam)
{
	switch (message) {
    case WM_CREATE:
//		InitializeGLWindow();	
	break;

	case WM_COMMAND: 
            switch (LOWORD(wParam)) 
            { 
				case IDOK: 
	
                break;
            }
	break;
//	case WM_ERASEBKGND:
//			RedrawGLWindow();
//			SwapBuffers(hDC);
//	break;
//	case WM_PAINT:
//			RedrawGLWindow();
//			SwapBuffers(hDC);
//	break;

	case WM_CLOSE:
	//case WM_DESTROY:
		
		//PostQuitMessage(0);
		bDone = true;
		return 0;
	break;
	case WM_SIZE :
		WindowWidth = LOWORD(lParam);
		WindowHeight = HIWORD(lParam);
		ResizeGLWindow(WindowWidth, WindowHeight);
	break;
 	}
    return DefWindowProc(hWnd, message, wParam, lParam);
}
